* --------------------------------------------------------------------------- *
*						     FISC/SKID-ROW H.A.M BOOT *
*						       Ecrit par FLASHER JACK *
* --------------------------------------------------------------------------- *
* pour installer (AsmOne):
*	WS<RET>
*	location<RET>
*	0<RET>
*	2<RET>
*	CC<RET>
* --------------------------------------------------------------------------- *

* ---------------------------------------------------------------- constantes *
location		equ	$30000

* ------------------------------------------------- commandes macro assembler *
waitblt			macro
waitblt\@		btst.b	#6,(a5)
			bne.b	waitblt\@
			endm

* ------------------------------------------------------- localisation du prg *
			jmp	location
			org	location
			load	location

* -------------------------------------------------------------- debut du prg *
debut			dc.b	"DOS",0
			dc.l	0,880
			movem.l	d0-a6,-(a7)
			lea.l	var(pc),a6
			lea.l	$dff002,a5
			move.w	(a5),d0
			or.w	d0,sauve_dma+2-var(a6)
			clr.l	$140-2(a5)

			lea.l	$70000,a0
			lea.l	44(a0),a1
vide_log		clr.l	(a0)+
			cmp.l	#$75000,a0
			bcs.b	vide_log

			lea.l	logo-var(a6),a0
			lea.l	logo2-var(a6),a2
			moveq.l	#5-1,d7
copy_logo		move.l	(a0)+,(a1)+
			move.w	(a2)+,(a1)
			lea.l	40-4(a1),a1
			dbf	d7,copy_logo

			lea.l	(a6),a0				* vide les
			lea.l	image+(88*6)+(88*6)+(88*2)-var(a6),a1
vide_image		clr.l	(a0)+				* plans
			cmp.l	a1,a0				* de l'image
			bcs.b	vide_image

			lea.l	image2-var(a6),a0
			move.l	a0,d0				* les plans
			lea.l	image_bps+2-var(a6),a0		* dans la
			moveq.l	#88,d1				* copperlist
			moveq.l	#6-1,d7
copy_bps		move.w	d0,4(a0)
			swap.w	d0
			move.w	d0,(a0)
			swap.w	d0
			add.l	d1,d0
			addq.l	#8,a0
			dbf	d7,copy_bps

			lea.l	sin_table-var(a6),a0		* creation
			lea.l	fin_sin_table-var(a6),a1	* de la table
			move.w	#256-1,d7			* a partir
			lea.l	table-var(a6),a2		* des offsets
copy_table		move.b	-(a1),d0
			not.b	d0
			move.b	d0,256(a2)
			move.b	(a0)+,(a2)+
			dbf	d7,copy_table
			lea.l	256(a2),a2
			lea.l	(a2),a3
			moveq.l	#6-1,d4
			move.w	#512-1,d5
copy_table_inverse	move.b	-(a2),(a3)+
			dbf	d5,copy_table_inverse
			move.w	#1024-1,d5			* prochain
			lea.l	table+1024-var(a6),a2		* passage
			dbf	d4,copy_table_inverse

			lea.l	(a6),a0				* creation de
			lea.l	masque_table-var(a6),a2
			moveq.l	#6-1,d7
			moveq.l	#0,d6
copy_masque_ligne	movem.w	image_table-var(a6),d0-d3
			move.b	(a2)+,d4
			move.b	(a2)+,d5
			ext.w	d4
			ext.w	d5
			cmp.w	#3,d6
			blt.b	pas_not
			not.w	d0
			not.w	d1
			not.w	d2
			not.w	d3
pas_not			move.w	d4,(88*5)(a0)			* les 6 plans
			move.w	d5,(88*4)(a0)
			move.w	d3,(88*3)(a0)
			move.w	d2,(88*2)(a0)
			move.w	d1,88(a0)
			move.w	d0,(a0)+
			or.w	d0,d1				* rassemble
			or.w	d1,d2				* pour le
			or.w	d2,d3				* masque
			or.w	d3,d4
			or.w	d4,d5
			move.w	d5,(88*6)-2(a0)
			addq.w	#1,d6
			dbf	d7,copy_masque_ligne
		
			moveq.l	#-1,d0
			move.l	d0,$44-2(a5)
			lea.l	copper-var(a6),a0		* affiche la
			move.l	a0,$80-2(a5)			* copperlist
			move.l	$80.w,sauve_trap0+2-var(a6)
			lea.l	souris-var(a6),a0
			move.l	a0,$80.w
			trap	#0

			move.l	4.w,a6
			move.l	156(a6),a6
			move.l	38(a6),$80-2(a5)
sauve_trap0		move.l	#0,$80.w
			movem.l	(a7)+,d0-a6

			lea.l	dosname(pc),a1
			jsr	-96(a6)
			move.l	d0,a0
			move.l	22(a0),a0
			moveq.l	#0,d0
			rts

* ------------------------------------------------------------- boucle du prg *
souris			cmp.b	#245,6-2(a5)
			bne.b	souris

			lea.l	image2-var(a6),a2
			move.l	#$1000000,$40-2(a5)
			clr.w	$66-2(a5)
			move.l	a2,$54-2(a5)
			move.w	#(5*64)+44,$58-2(a5)
			waitblt

			moveq.l	#88-14,d0
			move.w	d0,$60-2(a5)
			move.w	d0,$62-2(a5)
			move.w	d0,$64-2(a5)
			move.w	d0,$66-2(a5)

			lea.l	x_pointeur-var(a6),a0
			addq.w	#6,(a0)
			and.w	#$3fe,(a0)
			move.w	(a0),d3
			lea.l	mask-var(a6),a0
			lea.l	image2+2-var(a6),a2
			lea.l	table-var(a6),a3
			moveq.l	#39-1,d7
			moveq.l	#(1*64)+7,d4
			moveq.l	#88,d5
copy_barres		lea.l	(a6),a1
			lea.l	(a2),a4
			moveq.l	#0,d0
			move.b	(a3,d3.w),d0
			move.w	d0,d2
			lsr.w	#3,d0
			and.w	#$f,d2
			ror.w	#4,d2
			move.w	d2,$42-2(a5)
			or.w	#$fe2,d2
			move.w	d2,$40-2(a5)
			add.w	d0,a4
			moveq.l	#6-1,d6
copy_bps_barres		movem.l	a0/a1/a4,$4c-2(a5)
			move.l	a4,$48-2(a5)
			move.w	d4,$58-2(a5)
			add.l	d5,a1
			add.l	d5,a4
			dbf	d6,copy_bps_barres
			lea.l	20(a3),a3
			dbf	d7,copy_barres

			btst.b	#6,$bfe001
			bne.w	souris

* ---------------------------------------------------------------- fin du prg *
sauve_dma		move.w	#$8000,$96-2(a5)
			rte

* ----------------------------------------------------------------- variables *
* image des barres
* ces 4 mots representent les 4 plans pour le choix des 16 couleurs
image_table		dc.w	%0101010101010101
			dc.w	%0011001100110011
			dc.w	%0000111100001111
			dc.w	%0000000011111111
* ces 2 mots representent les choix des masques pour la composante:
* 	   %1 %0 = tranformation vers le rouge (soustraction de $f00)
*	   %1 %1 = tranformation vers le vert  (soustraction de $0f0)
*	   %0 %1 = tranformation vers le bleu  (soustraction de $00f)
masque_table		dc.b	0,0
			dc.b	0,-1
			dc.b	-1,-1
			dc.b	-1,0
 			dc.b	-1,-1
 			dc.b	0,-1
dosname			dc.b	"dos.library",0
copper			dc.w	$8e,$2c81,$90,$faff
			dc.w	$92,$28,$94,$e0,$96,$20,$96,$87c0
image_bps		dc.w	$e0,0,$e2,0,$e4,0,$e6,0,$e8,0,$ea,0
			dc.w	$ec,0,$ee,0,$f0,0,$f2,0,$f4,0,$f6,0
			dc.w	$100,$6a00,$102,0
			dc.w	$108,-46,$10a,-46
			dc.w	$180,$000,$182,$000,$184,$200,$186,$300
			dc.w	$188,$400,$18a,$500,$18c,$600,$18e,$700
			dc.w	$190,$800,$192,$900,$194,$a00,$196,$b00
			dc.w	$198,$c00,$19a,$d00,$19c,$e00,$19e,$f00
			dc.w	$2c09,-2,$180,4
			dc.w	$f409,-2,$180,0,$182,$665,$90,$fac1
			dc.w	$e0,7,$e2,0,$100,$1200,$108,-6
			dc.l	-2
sin_table		dc.b	$00,$00,$00,$00,$00,$00,$00,$00
			dc.b	$00,$00,$00,$00,$00,$00,$01,$01
			dc.b	$01,$01,$01,$01,$01,$01,$01,$01
			dc.b	$01,$02,$02,$02,$02,$02,$02,$02
			dc.b	$03,$03,$03,$03,$03,$03,$04,$04
			dc.b	$04,$04,$04,$05,$05,$05,$05,$05
			dc.b	$06,$06,$06,$06,$07,$07,$07,$07
			dc.b	$08,$08,$08,$09,$09,$09,$09,$0a
			dc.b	$0a,$0a,$0b,$0b,$0b,$0c,$0c,$0c
			dc.b	$0d,$0d,$0d,$0e,$0e,$0e,$0f,$0f
			dc.b	$0f,$10,$10,$11,$11,$11,$12,$12
			dc.b	$13,$13,$13,$14,$14,$15,$15,$15
			dc.b	$16,$16,$17,$17,$18,$18,$19,$19
			dc.b	$1a,$1a,$1b,$1b,$1b,$1c,$1c,$1d
			dc.b	$1d,$1e,$1e,$1f,$1f,$20,$21,$21
			dc.b	$22,$22,$23,$23,$24,$24,$25,$25
			dc.b	$26,$26,$27,$28,$28,$29,$29,$2a
			dc.b	$2a,$2b,$2c,$2c,$2d,$2d,$2e,$2f
			dc.b	$2f,$30,$30,$31,$32,$32,$33,$34
			dc.b	$34,$35,$35,$36,$37,$37,$38,$39
			dc.b	$39,$3a,$3b,$3b,$3c,$3d,$3d,$3e
			dc.b	$3f,$3f,$40,$41,$41,$42,$43,$43
			dc.b	$44,$45,$45,$46,$47,$48,$48,$49
			dc.b	$4a,$4a,$4b,$4c,$4d,$4d,$4e,$4f
			dc.b	$4f,$50,$51,$52,$52,$53,$54,$55
			dc.b	$55,$56,$57,$58,$58,$59,$5a,$5a
			dc.b	$5b,$5c,$5d,$5d,$5e,$5f,$60,$61
			dc.b	$61,$62,$63,$64,$64,$65,$66,$67
			dc.b	$67,$68,$69,$6a,$6a,$6b,$6c,$6d
			dc.b	$6e,$6e,$6f,$70,$71,$71,$72,$73
			dc.b	$74,$75,$75,$76,$77,$78,$78,$79
			dc.b	$7a,$7b,$7c,$7c,$7d,$7e,$7f,$7f
fin_sin_table	
logo			dc.l	%11101011101110000011101010101100
			dc.l	%10001010001000001010001010101010
			dc.l	%11001011101000010011101100101010
			dc.l	%10001000101000100000101010101010
			dc.l	%10001011101110000011101010101100
logo2			dc.w	%0000111011101010
			dc.w	%0000101010101010
			dc.w	%1110110010101010
			dc.w	%0000101010101110
			dc.w	%0000101011101010
			even

* --------------------------------------------------------------------- datas *
var
image			equ	var
mask			equ	image+(88*6)
image2			equ	mask+88
x_pointeur		equ	image2+(88*6)
table			equ	x_pointeur+2
fin			end
